internal::function_input_queue< T, A > Class Template Reference

`#include <_flow_graph_node_impl.h>`

Inheritance diagram for internal::function_input_queue< T, A >:
Collaboration diagram for internal::function_input_queue< T, A >:

## Public Member Functions

bool | empty () const
const T & | front () const
bool | pop (T &t)
void | pop ()
bool | push (T &t)
Public Member Functions inherited from internal::item_buffer< T, A >
| item_buffer ()
| Constructor. More...
| ~item_buffer ()
void | reset ()

## Additional Inherited Members

Public Types inherited from internal::item_buffer< T, A >
enum | buffer_item_state
typedef T | item_type
Protected Types inherited from internal::item_buffer< T, A >
typedef size_t | size_type
typedef aligned_pair< item_type, buffer_item_state >::type | buffer_item_type
typedef tbb::internal::allocator_rebind< A, buffer_item_type >::type | allocator_type
Protected Member Functions inherited from internal::item_buffer< T, A >
bool | buffer_empty () const
buffer_item_type & | item (size_type i)
const buffer_item_type & | item (size_type i) const
bool | my_item_valid (size_type i) const
bool | my_item_reserved (size_type i) const
const item_type & | get_my_item (size_t i) const
void | set_my_item (size_t i, const item_type &o)
void | fetch_item (size_t i, item_type &o)
void | move_item (size_t to, size_t from)
bool | place_item (size_t here, const item_type &me)
void | swap_items (size_t i, size_t j)
void | destroy_item (size_type i)
const item_type & | front () const
const item_type & | back () const
void | reserve_item (size_type i)
void | release_item (size_type i)
void | destroy_front ()
void | destroy_back ()
size_type | size (size_t new_tail=0)
size_type | capacity ()
bool | buffer_full ()
void | grow_my_array (size_t minimum_size)
| Grows the internal array. More...
bool | push_back (item_type &v)
bool | pop_back (item_type &v)
bool | pop_front (item_type &v)
void | clean_up_buffer (bool reset_pointers)
Protected Attributes inherited from internal::item_buffer< T, A >
buffer_item_type * | my_array
size_type | my_array_size
size_type | my_head
size_type | my_tail
Static Protected Attributes inherited from internal::item_buffer< T, A >
static const size_type | initial_buffer_size

## Detailed Description

### template<typename T, typename A>
class internal::function_input_queue< T, A >

Definition at line 34 of file _flow_graph_node_impl.h.

## Member Function Documentation

## empty()

template<typename T , typename A >

bool internal::function_input_queue< T, A >::empty | ( |  | ) | const

inline

Definition at line 36 of file _flow_graph_node_impl.h.

{
return this->buffer_empty();
}
internal::item_buffer< T, A >::buffer_empty
bool buffer_empty() const
Definition: _flow_graph_item_buffer_impl.h:54

References internal::item_buffer< T, A >::buffer_empty().

Referenced by internal::function_input_base< Input, Policy, A, ImplType >::perform_queued_requests().

Here is the call graph for this function:
Here is the caller graph for this function:

## front()

template<typename T , typename A >

const T& internal::function_input_queue< T, A >::front | ( |  | ) | const

inline

Definition at line 40 of file _flow_graph_node_impl.h.

{
return this->item_buffer<T, A>::front();
}
internal::item_buffer::front
const item_type & front() const
Definition: _flow_graph_item_buffer_impl.h:129

References internal::item_buffer< T, A >::front().

Referenced by internal::function_input_base< Input, Policy, A, ImplType >::perform_queued_requests().

Here is the call graph for this function:
Here is the caller graph for this function:

## pop() [1/2]

template<typename T , typename A >

void internal::function_input_queue< T, A >::pop | ( |  | ) |

inline

Definition at line 48 of file _flow_graph_node_impl.h.

{
this->destroy_front();
}
internal::item_buffer< T, A >::destroy_front
void destroy_front()
Definition: _flow_graph_item_buffer_impl.h:146

References internal::item_buffer< T, A >::destroy_front().

Here is the call graph for this function:

## pop() [2/2]

template<typename T , typename A >

bool internal::function_input_queue< T, A >::pop | ( | T & | t | ) |

inline

Definition at line 44 of file _flow_graph_node_impl.h.

{
return this->pop_front( t );
}
internal::item_buffer< T, A >::pop_front
bool pop_front(item_type &v)
Definition: _flow_graph_item_buffer_impl.h:203

References internal::item_buffer< T, A >::pop_front().

Referenced by internal::function_input_base< Input, Policy, A, ImplType >::perform_queued_requests().

Here is the call graph for this function:
Here is the caller graph for this function:

## push()

template<typename T , typename A >

bool internal::function_input_queue< T, A >::push | ( | T & | t | ) |

inline

Definition at line 52 of file _flow_graph_node_impl.h.

{
return this->push_back( t );
}
internal::item_buffer< T, A >::push_back
bool push_back(item_type &v)
Definition: _flow_graph_item_buffer_impl.h:185

References internal::item_buffer< T, A >::push_back().

Referenced by internal::function_input_base< Input, Policy, A, ImplType >::internal_try_put_task().

Here is the call graph for this function:
Here is the caller graph for this function:

The documentation for this class was generated from the following file:

- _flow_graph_node_impl.h

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.